#include "descriptor/descriptor.h"

int main(void) {

  ITEM	brown, gray30, glass, esterno, black, light_post_att, light_ant_att;
  ITEM	muro_att, sedili_att, comandi_att, pannello_att, sotto_att, body_eliche_att;
  
  ITEM	elicopter_body, elicopter_body_sx, elicopter_body_dx, elicopter_glass, eliche_post, body_eliche_princ_up, body_eliche_princ_down;
  ITEM	/*doors, */piedi, tubi_post, light_post_obj, light_ant_obj;
  ITEM	muro_obj, sedili_obj, comandi_obj, sotto_obj, eliche_princ, body_eliche_post, ali_esterne_int, ali_esterne_ext;
  ITEM	pannello_princ_retro, pannello_princ_front, pannello_elle, terreno;
  
  ITEM	scene, elicopter, elica_princ, elica_post;

  set_background(0.676,0.861,0.953,TRUE);
  set_ambient_light(1,1,1,0.8);
  create_point_light(16.16,15.90,9.39,1,1,1,3.89,20, "light1");
  create_point_light(12,-12,9,1,1,1,4,20, "light2");
  create_point_light(2.33,-0.25,20.21,1,1,1,3.29,30, "light3");
  create_point_light(1.33,-0.25,-12.5,1,1,1,1.0,25, "light4");
  create_point_light(-1.33,4.25,0.5,1,1,1,0.4,15, "light5");
  

  /*** ATTRIBUTE esterno ***/
  esterno = create_attribute("esterno");
  set_color(esterno,0.94,0.93,0.85,0.2,0.4);
  set_reflectivity(esterno,0.05,12);
  
  /*** ATTRIBUTE light_post_att ***/
  light_post_att = create_attribute("light_post");
  set_color(light_post_att,0.88,0.14,0.19,0.2,0.6);
  set_reflectivity(light_post_att,0.1,15);
  set_transparency(light_post_att,0.4,0.2,1,1.2);
  
  /*** ATTRIBUTE light_ant_att ***/
  light_ant_att = create_attribute("light_ant");
  set_color(light_ant_att,0.88,0.84,0.85,0.2,0.6);
  set_reflectivity(light_ant_att,0.1,15);
  set_transparency(light_ant_att,0.6,0.3,1,1.2);
  
  /*** ATTRIBUTE muro_att ***/
  muro_att = create_attribute("muro");
  set_color(muro_att,0.31,0.32,0.1,0.2,0.6);
  //set_reflectivity(muro_att,0.1,15);
  
  /*** ATTRIBUTE sedili_att ***/
  sedili_att = create_attribute("sedili");
  set_color(sedili_att,0.71,0.6,0.35,0.2,0.6);
  //set_reflectivity(sedili_att,0.1,15);
  
  /*** ATTRIBUTE comandi_att ***/
  comandi_att = create_attribute("comandi");
  set_color(comandi_att,0.1,0.1,0.1,0.2,0.6);
  set_reflectivity(sedili_att,0.15,30);
  
  /*** ATTRIBUTE pannello ***/
  pannello_att = create_attribute("pannello");
  set_color(pannello_att,0,0,0,0.2,0.6);
  set_reflectivity(pannello_att,0.15,30);
  
  /*** ATTRIBUTE sotto_att ***/
  sotto_att = create_attribute("sotto");
  set_color(sotto_att,0.46,0.50,0.47,0.2,0.6);
  set_reflectivity(sotto_att,0.05,30);
  
  /*** ATTRIBUTE body_eliche_att ***/
  body_eliche_att = create_attribute("body_eliche");
  //set_color(body_eliche_att,0.61,0.65,0.62,0.2,0.8);
  set_color(body_eliche_att,0.84,0.83,0.75,0.2,0.6);
  set_reflectivity(body_eliche_att,0.05,30);
  
  /*** ATTRIBUTE black ***/
  black = create_attribute("black");
  set_color(black,0,0,0,0.2,0.6);
  set_reflectivity(black,0.05,15);
  
  /*** ATTRIBUTE grey30 ***/
  gray30 = create_attribute("gray30");
  set_color(gray30,0.3,0.3,0.3,0.2,0.4);
  set_reflectivity(gray30,0.02,10);
  
  /*** ATTRIBUTE glass ***/
  glass = create_attribute("glass");
  set_color(glass,0.2,0.36,0.20,0.5,0.6);
  set_reflectivity(glass,0.24,2);
  set_transparency(glass,0.9,0.6,1,1.2);

  
  /*teapot_glass = read_obj("teapot.obj", "glass_teapot");*/
  elicopter_body = read_obj("body_noVetro.obj", "body_noVetro");
  elicopter_body_sx = read_obj("body_princ_sx.obj", "body_princ_sx");
  elicopter_body_dx = read_obj("body_princ_dx.obj", "body_princ_dx");
  elicopter_glass = read_obj("vetro.obj", "vetro");
 // doors = read_obj("doors.obj", "doors");
  piedi = read_obj("piedi.obj", "piedi");
  tubi_post = read_obj("tubi_post.obj", "tubi_post");
  
  eliche_post = read_obj("eliche_post.obj", "eliche_post");
  body_eliche_post = read_obj("eliche_post_noE.obj", "body_eliche_post");
  body_eliche_princ_up = read_obj("body_up_noE.obj", "body_up");
  body_eliche_princ_down = read_obj("body_down.obj", "body_down");
  eliche_princ = read_obj("eliche_princ.obj", "eliche_princ");
  
  ali_esterne_int = read_obj("ali_esterne_int.obj", "ali_esterne_int");
  ali_esterne_ext = read_obj("ali_esterne_ext.obj", "ali_esterne_ext");
  
  light_post_obj = read_obj("light_post.obj", "light_post");
  light_ant_obj = read_obj("light_ant.obj", "light_ant");
  
  pannello_princ_retro = read_obj("pannello_princ_retro.obj", "pannello_princ_retro");
  pannello_princ_front = read_obj("pannello_princ_front.obj", "pannello_princ_front");
  pannello_elle = read_obj("pannello_elle.obj", "pannello_elle");
  
  muro_obj = read_obj("muro.obj", "muro");
  sedili_obj = read_obj("sedili.obj", "sedili");
  comandi_obj = read_obj("comandi.obj", "comandi");
  sotto_obj = read_obj("sotto.obj", "sotto");
  
  terreno = read_obj("terreno.obj", "terreno");

  set_attribute(elicopter_body,esterno);
  set_attribute(elicopter_body_sx,esterno);
  set_attribute(elicopter_body_dx,esterno);
 
  set_attribute(eliche_post,body_eliche_att);
  set_attribute(body_eliche_post,body_eliche_att);
  set_attribute(body_eliche_princ_up,body_eliche_att);
  set_attribute(body_eliche_princ_down,body_eliche_att);
  set_attribute(eliche_princ,body_eliche_att);
  
  //set_attribute(doors,sotto_att);
  set_attribute(piedi,gray30);
  set_attribute(tubi_post,black);
  set_attribute(elicopter_glass,glass);
  
  set_attribute(ali_esterne_int,esterno);
  set_attribute(ali_esterne_ext,esterno);
  
  set_attribute(light_post_obj,light_post_att);
  set_attribute(light_ant_obj,light_ant_att);
  
  set_attribute(pannello_princ_front,pannello_att);
  set_attribute(pannello_princ_retro,pannello_att);
  set_attribute(pannello_elle,pannello_att);
  
  set_attribute(muro_obj,muro_att);
  set_attribute(sedili_obj,sedili_att);
  set_attribute(comandi_obj,comandi_att);
  set_attribute(sotto_obj,sotto_att);
  
  set_attribute(terreno,gray30);
  
  /*** Eliche posteriori ***/
  set_translate(eliche_post, 2.278031,-0.05248809,-0.6007273);
  set_z_rotate(eliche_post, -90, 1);
  set_scale(eliche_post, 1/0.748, 1/0.748, 1/0.748);
  set_projection_texture(eliche_post, body_eliche_att, "textures/Asptra.hr", 0, FALSE, 0.3, 0.6);
  set_scale(eliche_post, 0.748, 0.748, 0.748);
  set_z_rotate(eliche_post, 90, 1);
  set_translate(eliche_post, -2.278031,0.05248809,0.6007273);
  
  /*** Ali esterne ***/
  set_translate(ali_esterne_ext, 1.640438,0,0.04);
  set_z_rotate(ali_esterne_ext, -90, 1);
  set_x_rotate(ali_esterne_ext, -90, 1);
  set_scale(ali_esterne_ext, 1/0.23, 1/0.23, 1/0.23);
  set_projection_texture(ali_esterne_ext, esterno, "textures/Bander2.hr", 0, FALSE, 0.3, 0.6);
  set_scale(ali_esterne_ext, 0.23, 0.23, 0.23);
  set_x_rotate(ali_esterne_ext, 90, 1);
  set_z_rotate(ali_esterne_ext, 90, 1);
  set_translate(ali_esterne_ext, -1.640438,0,-0.04);
  
  /*** Body DX ***/
  //set_translate(elicopter_body_dx, -1.59572,0.00877,0.28076);
  set_translate(elicopter_body_dx, -0.3,0,0.18);
  set_z_rotate(elicopter_body_dx, -90, 1);
  set_x_rotate(elicopter_body_dx, 92, 1);
  set_z_rotate(elicopter_body_dx, -180, 1);
  set_scale(elicopter_body_dx, 1/1.4, 1/1.15, 1/2.64);
  set_projection_texture(elicopter_body_dx, esterno, "textures/Lat2_ok.hr", 0, FALSE, 0.3, 0.6);
  set_scale(elicopter_body_dx, 1.4, 1.15, 2.64);
  set_z_rotate(elicopter_body_dx, 180, 1);
  set_x_rotate(elicopter_body_dx, -92, 1);
  set_z_rotate(elicopter_body_dx, 90, 1);
  set_translate(elicopter_body_dx, 0.3,0,-0.18);
  //set_translate(elicopter_body_dx, 1.59572,-0.00877,-0.28076);
  
  /*** Body SX ***/
  //set_translate(elicopter_body_sx, -1.59572,0.00877,0.28076);
  set_translate(elicopter_body_sx, -0.3,0,0.18);
  set_z_rotate(elicopter_body_sx, -90, 1);
  set_x_rotate(elicopter_body_sx, 92, 1);
  set_z_rotate(elicopter_body_sx, -180, 1);
  set_scale(elicopter_body_sx, 1/1.4, 1/1.1, 1/2.67);
  set_projection_texture(elicopter_body_sx, esterno, "textures/Lat1_ok.hr", 0, FALSE, 0.3, 0.6);
  set_scale(elicopter_body_sx, 1.4, 1.1, 2.67);
  set_z_rotate(elicopter_body_sx, 180, 1);
  set_x_rotate(elicopter_body_sx, -92, 1);
  set_z_rotate(elicopter_body_sx, 90, 1);
  set_translate(elicopter_body_sx, 0.3,0,-0.18);
  //set_translate(elicopter_body_sx, 1.59572,-0.00877,-0.28076);
  
  /*** Pannello Principale ***/
  set_translate(pannello_princ_front, -2.576459,0.03910971,0.5038521);
  set_x_rotate(pannello_princ_front, -90, 1);
  set_translate(pannello_princ_front, 0,-0.11,-0.01);
  set_scale(pannello_princ_front, 1/0.1, 1/0.12, 1/0.1);
  set_projection_texture(pannello_princ_front, pannello_att, "textures/Pann_princ.hr", 0, FALSE, 0.3, 0.6);
  set_scale(pannello_princ_front, 0.1, 0.12, 0.1);
  set_translate(pannello_princ_front, 0,0.11,0.01);
  set_x_rotate(pannello_princ_front, 90, 1);
  set_translate(pannello_princ_front, 2.576459,-0.03910971,-0.5038521);
  
  /*** Pannello Elle ***/
  set_translate(pannello_elle, -2.392503,0.03969487,0.7093385);
  set_y_rotate(pannello_elle, -90, 1);
  set_x_rotate(pannello_elle, -90, 1);
  set_translate(pannello_elle, 0,0.02,0);
  set_scale(pannello_elle, 1/0.1, 1/0.1, 1/0.08);
  set_projection_texture(pannello_elle, pannello_att, "textures/Pann_elle2.hr", 0, FALSE, 0.3, 0.6);
  set_scale(pannello_elle, 0.1, 0.1, 0.08);
  set_translate(pannello_elle, 0,-0.02,0);
  set_x_rotate(pannello_elle, 90, 1);
  set_y_rotate(pannello_elle, 90, 1);
  set_translate(pannello_elle, 2.392503,-0.03969487,-0.7093385);
  
  /*** terreno ***/
  //set_translate(terreno, 2.278031,-0.05248809,-0.6007273);
  set_y_rotate(terreno, -90, 1);
  set_x_rotate(terreno, 90, 1);
  set_scale(terreno, 1/17.5, 1/17.5, 1/17.5);
  set_projection_texture(terreno, gray30, "textures/pista6.hr", 0, FALSE, 0.2, 0.4);
  set_scale(terreno, 17.5, 17.5, 17.5);
  set_x_rotate(terreno, -90, 1);
  set_y_rotate(terreno, 90, 1);
  //set_translate(terreno, -2.278031,0.05248809,0.6007273);
  
  
  elica_post = create_list(eliche_post, "elica_post");
  elica_post = insert_in_list(elica_post,body_eliche_post);
  
  elica_princ = create_list(eliche_princ, "elica_princ");
  elica_princ = insert_in_list(elica_princ,body_eliche_princ_up);
  
  elicopter = create_list(elicopter_body_dx, "elicopter");
  elicopter = insert_in_list(elicopter,elicopter_body_sx);
  elicopter = insert_in_list(elicopter,elicopter_body);
  elicopter = insert_in_list(elicopter,elicopter_glass);
  elicopter = insert_in_list(elicopter,body_eliche_princ_down);
  elicopter = insert_in_list(elicopter,piedi);
  elicopter = insert_in_list(elicopter,tubi_post);
  elicopter = insert_in_list(elicopter,ali_esterne_ext);
  elicopter = insert_in_list(elicopter,ali_esterne_int);
  elicopter = insert_in_list(elicopter,light_post_obj);
  elicopter = insert_in_list(elicopter,light_ant_obj);
  elicopter = insert_in_list(elicopter,pannello_princ_front);
  elicopter = insert_in_list(elicopter,pannello_princ_retro);
  elicopter = insert_in_list(elicopter,pannello_elle);
  elicopter = insert_in_list(elicopter,muro_obj);
  elicopter = insert_in_list(elicopter,sedili_obj);
  elicopter = insert_in_list(elicopter,comandi_obj);
  elicopter = insert_in_list(elicopter,sotto_obj);
  
  elicopter = insert_in_list(elicopter,elica_post);
  elicopter = insert_in_list(elicopter,elica_princ);
  
  scene = create_list(terreno, "scene");
  scene = insert_in_list(scene,elicopter);
  
  save_scene("elicottero.md","scene_elicottero",scene);
  
  return(0);
}
